function Trec12()
dataName = './data/UFdatasets/Trec12.mat';
fileName = './results/real/Trec12';


load(dataName);
A = full(Problem.A);
A(A>20)=0;
A = A';
N = A;
N(N==0)=nan;

save(fileName, 'A', 'N', '-append');

% [B_,C_] = Capricorn(N, k, 'MAX_CYCLES', 3);
% save(fileName, 'B_', 'C_');

% Which setups to run.
Cap10 = 1;
Cap15 = 1;
Cap20 = 1;
Cap25 = 1;
Cap30 = 1;

NMF10 = 1;
NMF15 = 1;
NMF20 = 1;
NMF25 = 1;
NMF30 = 1;

SVD10 = 1;
SVD15 = 1;
SVD20 = 1;
SVD25 = 1;
SVD30 = 1;

WNMF10 = 1;
WNMF15 = 1;
WNMF20 = 1;
WNMF25 = 1;
WNMF30 = 1;


%% Run algorithms.
if Cap10 == 1
    [Bcap10, Ccap10] = Capricorn(N, 10, 'MAX_CYCLES', 2);
    save(fileName, 'Bcap10', 'Ccap10', '-append');
end

if Cap15 == 1
    [Bcap15, Ccap15] = Capricorn(N, 15, 'MAX_CYCLES', 2);
    save(fileName, 'Bcap15', 'Ccap15', '-append');
end

if Cap20 == 1
    [Bcap20, Ccap20] = Capricorn(N, 20, 'MAX_CYCLES', 2);
    save(fileName, 'Bcap20', 'Ccap20', '-append');
end

if Cap25 == 1
    [Bcap25, Ccap25] = Capricorn(N, 25, 'MAX_CYCLES', 2);
    save(fileName, 'Bcap25', 'Ccap25', '-append');
end

if Cap30 == 1
    [Bcap30, Ccap30] = Capricorn(N, 30, 'MAX_CYCLES', 2);
    save(fileName, 'Bcap30', 'Ccap30', '-append');
end


if NMF10 == 1
    [Bnmf10, Cnmf10] = nmfParkWrapper(A, 10);
    save(fileName, 'Bnmf10', 'Cnmf10', '-append');
end

if NMF15 == 1
    [Bnmf15, Cnmf15] = nmfParkWrapper(A, 15);
    save(fileName, 'Bnmf15', 'Cnmf15', '-append');
end

if NMF20 == 1
    [Bnmf20, Cnmf20] = nmfParkWrapper(A, 20);
    save(fileName, 'Bnmf20', 'Cnmf20', '-append');
end

if NMF25 == 1
    [Bnmf25, Cnmf25] = nmfParkWrapper(A, 25);
    save(fileName, 'Bnmf25', 'Cnmf25', '-append');
end

if NMF30 == 1
    [Bnmf30, Cnmf30] = nmfParkWrapper(A, 30);
    save(fileName, 'Bnmf30', 'Cnmf30', '-append');
end


if SVD10 == 1
    [Bsvd10, Csvd10] = svdWrapper(A, 10);
    save(fileName, 'Bsvd10', 'Csvd10', '-append');
end

if SVD15 == 1
    [Bsvd15, Csvd15] = svdWrapper(A, 15);
    save(fileName, 'Bsvd15', 'Csvd15', '-append');
end

if SVD20 == 1
    [Bsvd20, Csvd20] = svdWrapper(A, 20);
    save(fileName, 'Bsvd20', 'Csvd20', '-append');
end

if SVD25 == 1
    [Bsvd25, Csvd25] = svdWrapper(A, 25);
    save(fileName, 'Bsvd25', 'Csvd25', '-append');
end

if SVD30 == 1
    [Bsvd30, Csvd30] = svdWrapper(A, 30);
    save(fileName, 'Bsvd30', 'Csvd30', '-append');
end


if WNMF10 == 1
    [Bwnmf10, Cwnmf10, ~, ~, ~] = wnmfrule(N, 10);
    save(fileName, 'Bwnmf10', 'Cwnmf10', '-append');
end

if WNMF15 == 1
    [Bwnmf15, Cwnmf15, ~, ~, ~] = wnmfrule(N, 15);
    save(fileName, 'Bwnmf15', 'Cwnmf15', '-append');
end

if WNMF20 == 1
    [Bwnmf20, Cwnmf20, ~, ~, ~] = wnmfrule(N, 20);
    save(fileName, 'Bwnmf20', 'Cwnmf20', '-append');
end

if WNMF25 == 1
    [Bwnmf25, Cwnmf25, ~, ~, ~] = wnmfrule(N, 25);
    save(fileName, 'Bwnmf25', 'Cwnmf25', '-append');
end

if WNMF30 == 1
    [Bwnmf30, Cwnmf30, ~, ~, ~] = wnmfrule(N, 30);
    save(fileName, 'Bwnmf30', 'Cwnmf30', '-append');
end


%% Print results.
load(fileName);

if exist('Bcap10', 'var')
    printCapricorn(Bcap10, Ccap10, A, N);
end

if exist('Bnmf10', 'var')
    printNMF(Bnmf10, Cnmf10, A, N);
end

if exist('Bwnmf10', 'var')
    printWNMF(Bwnmf10, Cwnmf10, A, N);
end

if exist('Bsvd10', 'var')
    printSVD(Bsvd10, Csvd10, A, N);
end


if exist('Bcap15', 'var')
    printCapricorn(Bcap15, Ccap15, A, N);
end

if exist('Bnmf15', 'var')
    printNMF(Bnmf15, Cnmf15, A, N);
end

if exist('Bwnmf15', 'var')
    printWNMF(Bwnmf15, Cwnmf15, A, N);
end

if exist('Bsvd15', 'var')
    printSVD(Bsvd15, Csvd15, A, N);
end


if exist('Bcap20', 'var')
    printCapricorn(Bcap20, Ccap20, A, N);
end

if exist('Bnmf20', 'var')
    printNMF(Bnmf20, Cnmf20, A, N);
end

if exist('Bwnmf20', 'var')
    printWNMF(Bwnmf20, Cwnmf20, A, N);
end

if exist('Bsvd20', 'var')
    printSVD(Bsvd20, Csvd20, A, N);
end


if exist('Bcap25', 'var')
    printCapricorn(Bcap25, Ccap25, A, N);
end

if exist('Bnmf25', 'var')
    printNMF(Bnmf25, Cnmf25, A, N);
end

if exist('Bwnmf25', 'var')
    printWNMF(Bwnmf25, Cwnmf25, A, N);
end

if exist('Bsvd25', 'var')
    printSVD(Bsvd25, Csvd25, A, N);
end


if exist('Bcap30', 'var')
    printCapricorn(Bcap30, Ccap30, A, N);
end

if exist('Bnmf30', 'var')
    printNMF(Bnmf30, Cnmf30, A, N);
end

if exist('Bwnmf30', 'var')
    printWNMF(Bwnmf30, Cwnmf30, A, N);
end

if exist('Bsvd30', 'var')
    printSVD(Bsvd30, Csvd30, A, N);
end

end


function printCapricorn(B, C, A, N)
A_ = MaxProduct(B, C);
for i=1:14
    res(i) = nnz(abs(A_ - i) < 0.1 & A == i);
end
k = size(B, 2);
explained = 100 * nnz(abs(A - A_) < 0.5 & A~=0) / nnz(A);
L1error = 100 * nansum(nansum(abs(N - A_))) / nansum(nansum(N));
frobError = 100 * sqrt(nansum(nansum((N - A_).^2)) / nansum(nansum((N).^2)));
fracOnes = 100 * res(1) / sum(res);
% fprintf('Capricorn(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  fraction of 1s in explained: %d%%\n', ...
%     k, explained, L1error, frobError, fracOnes);
L1rest = 100 * L1Restricted(N, B, C, 0);
FrobRest = 100 * FrobRestricted(N, B, C, 0);
frac = 100 * nnz(A_.*A) / nnz(A);
fprintf('Cap(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  L1(rest): %d%%,  Frob(rest): %d%%,  Frac: %d%%\n', ...
    k, explained, L1error, frobError, L1rest, FrobRest, frac);
end


function printNMF(B, C, A, N)
A_ = B * C;
for i=1:14
    res(i) = nnz(abs(A_ - i) < 0.1 & A == i);
end
k = size(B, 2);
explained = 100 * nnz(abs(A - A_) < 0.5 & A~=0) / nnz(A);
L1error = 100 * nansum(nansum(abs(N - A_))) / nansum(nansum(N));
frobError = 100 * sqrt(nansum(nansum((N - A_).^2)) / nansum(nansum((N).^2)));
fracOnes = 100 * res(1) / sum(res);
% fprintf('NMF(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  fraction of 1s in explained: %d%%\n', ...
%     k, explained, L1error, frobError, fracOnes);
L1rest = 100 * L1Restricted(N, B, C, 1);
FrobRest = 100 * FrobRestricted(N, B, C, 1);
frac = 100 * nnz(A_.*A) / nnz(A);
fprintf('NMF(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  L1(rest): %d%%,  Frob(rest): %d%%,  Frac: %d%%\n', ...
    k, explained, L1error, frobError, L1rest, FrobRest, frac);
end


function printWNMF(B, C, A, N)
A_ = B * C;
for i=1:14
    res(i) = nnz(abs(A_ - i) < 0.1 & A == i);
end
k = size(B, 2);
explained = 100 * nnz(abs(A - A_) < 0.5 & A~=0) / nnz(A);
L1error = 100 * nansum(nansum(abs(N - A_))) / nansum(nansum(N));
frobError = 100 * sqrt(nansum(nansum((N - A_).^2)) / nansum(nansum((N).^2)));
fracOnes = 100 * res(1) / sum(res);
% fprintf('WNMF(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  fraction of 1s in explained: %d%%\n', ...
%     k, explained, L1error, frobError, fracOnes);
L1rest = 100 * L1Restricted(N, B, C, 1);
FrobRest = 100 * FrobRestricted(N, B, C, 1);
frac = 100 * nnz(A_.*A) / nnz(A);
fprintf('WNMF(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  L1(rest): %d%%,  Frob(rest): %d%%,  Frac: %d%%\n', ...
    k, explained, L1error, frobError, L1rest, FrobRest, frac);
end

function printSVD(B, C, A, N)
A_ = B * C;
for i=1:14
    res(i) = nnz(abs(A_ - i) < 0.1 & A == i);
end
k = size(B, 2);
explained = 100 * nnz(abs(A - A_) < 0.5 & A~=0) / nnz(A);
L1error = 100 * nansum(nansum(abs(N - A_))) / nansum(nansum(N));
frobError = 100 * sqrt(nansum(nansum((N - A_).^2)) / nansum(nansum((N).^2)));
fracOnes = 100 * res(1) / sum(res);
% fprintf('SVD(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  fraction of 1s in explained: %d%%\n', ...
%     k, explained, L1error, frobError, fracOnes);
L1rest = 100 * L1Restricted(N, B, C, 1);
FrobRest = 100 * FrobRestricted(N, B, C, 1);
frac = 100 * nnz(A_.*A) / nnz(A);
fprintf('SVD(%d)    explained: %d%%,  L1: %d%%,  Frob: %d%%,  L1(rest): %d%%,  Frob(rest): %d%%,  Frac: %d%%\n', ...
    k, explained, L1error, frobError, L1rest, FrobRest, frac);
end