function Trec12Time()
dataName = '/home/skaraev/workspace/tropic/trunk/data/UFdatasets/Trec12.mat';
fileName = './results/real/Trec12Time';


load(dataName);
A = full(Problem.A);
A(A>20)=0;
A = A';
N = A;
N(N==0)=nan;

% Which setups to run.
Cap10 = 0;
Cap15 = 0;
Cap20 = 0;
Cap25 = 0;
Cap30 = 0;

NMF10 = 1;
NMF15 = 1;
NMF20 = 1;
NMF25 = 1;
NMF30 = 1;

SVD10 = 1;
SVD15 = 1;
SVD20 = 1;
SVD25 = 1;
SVD30 = 1;

WNMF10 = 1;
WNMF15 = 1;
WNMF20 = 1;
WNMF25 = 1;
WNMF30 = 1;

%% Run algorithms.
if Cap10 == 1
    tic
    [Bcap10, Ccap10] = Capricorn(N, 10, 'MAX_CYCLES', 2);
    time10 = toc;    
    save(fileName, 'time10');
end

if Cap15 == 1
    tic
    [Bcap15, Ccap15] = Capricorn(N, 15, 'MAX_CYCLES', 2);
    time15 = toc;
    save(fileName, 'time15', '-append');
end

if Cap20 == 1
    tic
    [Bcap20, Ccap20] = Capricorn(N, 20, 'MAX_CYCLES', 2);
    time20 = toc;
    save(fileName, 'time20', '-append');
end

if Cap25 == 1
    tic
    [Bcap25, Ccap25] = Capricorn(N, 25, 'MAX_CYCLES', 2);
    time25 = toc;
    save(fileName, 'time25', '-append');
end

if Cap30 == 1
    tic
    [Bcap30, Ccap30] = Capricorn(N, 30, 'MAX_CYCLES', 2);
    time30 = toc;
    save(fileName, 'time30', '-append');
end

%% NMF
if NMF10 == 1
    tic
    [Bnmf10, Cnmf10] = nmfParkWrapper(A, 10);
    nmfTime10 = toc;
    save(fileName, 'nmfTime10', '-append');
end

if NMF15 == 1
    tic
    [Bnmf15, Cnmf15] = nmfParkWrapper(A, 15);
    nmfTime15 = toc;
    save(fileName, 'nmfTime15', '-append');
end

if NMF20 == 1
    tic
    [Bnmf20, Cnmf20] = nmfParkWrapper(A, 20);
    nmfTime20 = toc;
    save(fileName, 'nmfTime20', '-append');
end

if NMF25 == 1
    tic
    [Bnmf25, Cnmf25] = nmfParkWrapper(A, 25);
    nmfTime25 = toc;
    save(fileName, 'nmfTime25', '-append');
end

if NMF30 == 1
    tic
    [Bnmf30, Cnmf30] = nmfParkWrapper(A, 30);
    nmfTime30 = toc;
    save(fileName, 'nmfTime30', '-append');
end


%% SVD
if SVD10 == 1
    tic
    [Bsvd10, Csvd10] = svdWrapper(A, 10);
    svdTime10 = toc;
    save(fileName, 'svdTime10', '-append');
end

if SVD15 == 1
    tic
    [Bsvd15, Csvd15] = svdWrapper(A, 15);
    svdTime15 = toc;
    save(fileName, 'svdTime15', '-append');
end

if SVD20 == 1
    tic
    [Bsvd20, Csvd20] = svdWrapper(A, 20);
    svdTime20 = toc;
    save(fileName, 'svdTime20', '-append');
end

if SVD25 == 1
    tic
    [Bsvd25, Csvd25] = svdWrapper(A, 25);
    svdTime25 = toc;
    save(fileName, 'svdTime25', '-append');
end

if SVD30 == 1
    tic
    [Bsvd30, Csvd30] = svdWrapper(A, 30);
    svdTime30 = toc;
    save(fileName, 'svdTime30', '-append');
end


%% WNMF
if WNMF10 == 1
    tic
    [Bwnmf10, Cwnmf10] = wnmfrule(A, 10);
    wnmfTime10 = toc;
    save(fileName, 'wnmfTime10', '-append');
end

if WNMF15 == 1
    tic
    [Bwnmf15, Cwnmf15] = wnmfrule(A, 15);
    wnmfTime15 = toc;
    save(fileName, 'wnmfTime15', '-append');
end

if WNMF20 == 1
    tic
    [Bwnmf20, Cwnmf20] = wnmfrule(A, 20);
    wnmfTime20 = toc;
    save(fileName, 'wnmfTime20', '-append');
end

if WNMF25 == 1
    tic
    [Bwnmf25, Cwnmf25] = wnmfrule(A, 25);
    wnmfTime25 = toc;
    save(fileName, 'wnmfTime25', '-append');
end

if WNMF30 == 1
    tic
    [Bwnmf30, Cwnmf30] = wnmfrule(A, 30);
    wnmfTime30 = toc;
    save(fileName, 'wnmfTime30', '-append');
end