function [A, B, C, A_] = generateData(n, m, k, M, factorDensity, noiseLvelel, algebra)
rng(1);

%% Generate factors.
B = nan(n, k);
for i = 1 : n
    for j = 1 : k
        B(i, j) = randi(M);
    end
end
C = nan(k, m);
for i = 1 : k
    for j = 1 : m
        C(i, j) = randi(M);
    end
end

Bmask = rand(size(B)) < factorDensity;
Cmask = rand(size(C)) < factorDensity;
B = B .* Bmask;
C = C .* Cmask;

%% Get factor product.
if algebra == 0
    A = MaxProduct(B, C);
else
    A = MaxSum(B, C);
end

%% Add noise (the flipped values come from a uniform distribution between
%% min and max nonzero values in A)
idxNonzer = find(A~=0);
mn = min(A(idxNonzer));
mx = max(A(idxNonzer));
idx = rand(numel(A), 1) < noiseLvelel;
A_ = A;
A_(idx) = randi(mx-mn+1, nnz(idx), 1) + mn-1;