function generateDensityData(n, m, k, noise, minDens, densInc, densIters, nInstances, dataName)
% Find densities range.
densities = nan(densIters, 1);
for i = 1 : densIters
    densities(i) = minDens + (i-1)*densInc;
end

% Generate data.
for i = 1 : densIters
    for j = 1 : nInstances
        B = rand(n, k);
        C = rand(k, m);
        Bmask = rand(size(B)) < densities(i);
        Cmask = rand(size(C)) < densities(i);
        Borig{i}{j} = B .* Bmask;
        Corig{i}{j} = C .* Cmask;
        Aorig{i}{j} = MaxProduct(Borig{i}{j}, Corig{i}{j});
        Anoisy{i}{j} = Aorig{i}{j};
        % Add noise.
        targetDensity = nnz(Aorig{i}{j}) / numel(Aorig{i}{j});
        noisePattern = rand(size(Aorig{i}{j})) < noise * targetDensity;
        N = rand(size(Aorig{i}{j}));
        Anoisy{i}{j}(noisePattern) = N(noisePattern);
    end
end

save(dataName, 'Aorig', 'Anoisy', 'Borig', 'Corig');

end

