function generateDimData(n, m, noise, density, minK, incK, itersK, nInstances, dataName)
% Find dimentionality range.
dims = nan(itersK, 1);
for i = 1 : itersK
    dims(i) = minK + (i-1)*incK;
end

% Generate data.
for i = 1 : itersK
    for j = 1 : nInstances
        B = rand(n, dims(i));
        C = rand(dims(i), m);
        Bmask = rand(size(B)) < density;
        Cmask = rand(size(C)) < density;
        Borig{i}{j} = B .* Bmask;
        Corig{i}{j} = C .* Cmask;
        Aorig{i}{j} = MaxProduct(Borig{i}{j}, Corig{i}{j});
        Anoisy{i}{j} = Aorig{i}{j};
        % Add noise.
        targetDensity = nnz(Aorig{i}{j}) / numel(Aorig{i}{j});
        noisePattern = rand(size(Aorig{i}{j})) < noise * targetDensity;
        N = rand(size(Aorig{i}{j}));
        Anoisy{i}{j}(noisePattern) = N(noisePattern);
    end
end

save(dataName, 'Aorig', 'Anoisy', 'Borig', 'Corig');

end

