function [rowSetsPruned, colSetsPruned] = pruneIncreasingErrorBlocks(A, rowSets, colSets)
display('Prune blocks that increase error.');
eps_ = 0.01;
% For each row set find the best column set.
blockIdx = 1;
for i = 1 : numel(rowSets)
    for j = 1 : numel(colSets)
        [b, c] = recoverBlock(A, rowSets{i}, colSets{j});
        if L1(A, b, c, 0) < 1 - eps_
            rowSetsPruned{blockIdx} = rowSets{i};
            colSetsPruned{blockIdx} = colSets{j};
            blockIdx = blockIdx + 1;
        end
    end
end

end